%define __code_RVA_Localize__ _code_+_.text_RVA


bits 32


;int CALLBACK WinMain(
;  __in  HINSTANCE  hInstance,
;  __in  HINSTANCE  hPrevInstance,
;  __in  LPSTR      lpCmdLine,
;  __in  int        nCmdShow
;);

;Clear the direction flag so that string
;instructions like STOSB increment the
;ESI/EDI registers (i.e, read strings forward):
;;
 cld


;Get app identifier in EAX
;and put it into the structure:
;;;
 push byte 0
  call dword[GetModuleHandleA@KERNEL32.DLL]
 mov [WNDCLASSEX_mainWind.HINSTANCE.hInstance],eax

;HMODULE WINAPI GetModuleHandle(
;  __in_opt  LPCTSTR lpModuleName
;);


;Give the window background the current theme's
;button color:
;;
 mov eax,COLOR_BTNFACE+1
 mov [WNDCLASSEX_mainWind.HBRUSH.hbrBackground],eax


;Load a default system cursor for the window:
;;
 push dword IDC_APPSTARTING               ;LPCTSTR   lpCursorName
 push dword 0                             ;HINSTANCE hInstance
  call dword[LoadCursorA@USER32.DLL]
 mov [WNDCLASSEX_mainWind.HCURSOR.hCursor],eax    ;Put it into the window class

;HCURSOR WINAPI LoadCursor(
;  __in_opt  HINSTANCE  hInstance,
;  __in      LPCTSTR    lpCursorName
;);


;;Load the default EXE icon for the window:
;;;
 push dword CLOCKAPP_ICON1                            ;LPCTSTR   lpIconName
 push dword[WNDCLASSEX_mainWind.HINSTANCE.hInstance]  ;HINSTANCE hInstance
  call dword[LoadIconA@USER32.DLL]
 mov [WNDCLASSEX_mainWind.HICON.hIcon],eax     ;Put it into the window class

;HICON WINAPI LoadIcon(
;  __in_opt  HINSTANCE  hInstance,
;  __in      LPCTSTR    lpIconName
;);


;Register the window class:
;;
 push dword WNDCLASSEX_mainWind1
  call dword[RegisterClassExA@USER32.DLL]

;ATOM WINAPI RegisterClassEx(
;  __in  const WNDCLASSEX *lpwcx
;);


;Create the window:
;;
 push byte 0                                         ;LPVOID    lpParam
 push dword[WNDCLASSEX_mainWind.HINSTANCE.hInstance] ;HINSTANCE hInstance
 push byte 0                                         ;HMENU     hMenu
 push byte 0                                         ;HWND      hWndParent
 push dword 62                                       ;int       nHeight
 push dword 141                                      ;int       nWidth
 push dword 0                                        ;int       y
 push dword 0                                        ;int       x
 push dword WS_CAPTION|WS_SYSMENU                    ;DWORD     dwStyle
 push dword LPCTSTR.WindowTitle                      ;LPCTSTR   lpWindowName
 push dword LPCTSTR.ClassName                        ;LPCTSTR   lpClassName
 push dword WS_EX_TOOLWINDOW                         ;DWORD     dwExStyle
  call dword[CreateWindowExA@USER32.DLL]

;HWND WINAPI CreateWindowEx(
;  __in      DWORD      dwExStyle,
;  __in_opt  LPCTSTR    lpClassName,
;  __in_opt  LPCTSTR    lpWindowName,
;  __in      DWORD      dwStyle,
;  __in      int        x,
;  __in      int        y,
;  __in      int        nWidth,
;  __in      int        nHeight,
;  __in_opt  HWND       hWndParent,
;  __in_opt  HMENU      hMenu,
;  __in_opt  HINSTANCE  hInstance,
;  __in_opt  LPVOID     lpParam
;);



;If window couldn't be created, exit:
;;
 or eax,eax
 jnz All_OK    ;If all is OK, continue the program

 ;On window creation error, show an error message box
 ;and exit:
 ;;
  push dword MB_OK|MB_ICONERROR      ;UINT uType
  push dword 0                       ;LPCTSTR lpCaption
  push dword 0                       ;LPCTSTR lpText
  push dword 0                       ;HWND hWnd
   call dword[MessageBoxA@USER32.DLL]
    jmp ENDAPP


 All_OK:


;Save the window handle returned by CreateWindowExA:
;;
 mov [HWND.myhWnd1],eax


;Next, use HWND_TOPMOST to make the window permanently stay on top,
;even when it isn't active.
;
;Use the SWP_NOACTIVATE flag to make the window be shown
;non-focused at startup.
;
;Use the SWP_NOMOVE flag so that the X and Y
;parameters of SetWindowPos are ignored, preventing the window
;from being moved again on screen by SetWindowPos.
;
;Likewise, use the SWP_NOSIZE flag so that the cx and cy parameters of
;SetWindowPos are ignored, preventing the window from being
;resized by SetWindowPow:
;;
 push dword SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE    ;UINT uFlags
 push dword 0                                       ;int cy
 push dword 0                                       ;int cx
 push dword 0                                       ;int Y
 push dword 0                                       ;int X
 push dword HWND_TOPMOST                            ;HWND hWndInsertAfter
 push dword[HWND.myhWnd1]                           ;HWND hWnd
  call dword[SetWindowPos@USER32.DLL]

;BOOL WINAPI SetWindowPos(
;  __in      HWND  hWnd,
;  __in_opt  HWND  hWndInsertAfter,
;  __in      int   X,
;  __in      int   Y,
;  __in      int   cx,
;  __in      int   cy,
;  __in      UINT  uFlags
;);


;Now, use SW_SHOWNOACTIVATE to keep the window non-active
;when showing it with ShowWindow:
;;
 push SW_SHOWNOACTIVATE             ;int nCmdShow
 push dword[HWND.myhWnd1]           ;HWND hWnd
  call dword[ShowWindow@USER32.DLL]

;BOOL WINAPI ShowWindow(
;  __in  HWND  hWnd,
;  __in  int   nCmdShow
;);




;Below is a call to our main time function. This prints the current time count
;and then increases it for the next time it is called.
;
;We call the function here to display the time count since program
;startup. Otherwise, it would display until the timer we'll set up
;later fires the first time, and ALSO to prevent a WM_PAINT message
;from trying to repaint a hour:min:sec timer string that would be empty
;(to begin with) at this early startup point.
;;
 call time_updater


;Attempt to update the window contents:
;;
 push dword[HWND.myhWnd1]
  call dword[UpdateWindow@USER32.DLL]

;BOOL UpdateWindow(
;  __in  HWND hWnd
;);


;Set up the second-by-second timer:
;;
 push byte  0                    ;TIMERPROC lpTFunc
 push dword 1000                 ;UINT      wLength
 push byte  1                    ;UINT      nID
 push dword[HWND.myhWnd1]        ;HWND      hwnd
  call dword[SetTimer@USER32.DLL]

;UINT_PTR WINAPI SetTimer(
;  __in_opt  HWND       hWnd,
;  __in      UINT_PTR   nIDEvent,
;  __in      UINT       uElapse,
;  __in_opt  TIMERPROC  lpTimerFunc
;);











.WinMainLoop:

    ;Get a message, if possible:
    ;;
     push byte 0
     push byte 0
     push byte 0
     push dword MSG1
     call dword[GetMessageA@USER32.DLL]

    ;BOOL WINAPI GetMessage(
    ;  __out     LPMSG  lpMsg,
    ;  __in_opt  HWND   hWnd,
    ;  __in      UINT   wMsgFilterMin,
    ;  __in      UINT   wMsgFilterMax
    ;);


    ;Also check the return value of GetMessage in EAX.
    ;If GetMessage returned FALSE (0), we must terminate:
    ;;
     or eax,eax
     jz ENDAPP


    ;Hand the message to our WndrPoc:
    ;;
     push dword MSG1
     call dword[DispatchMessageA@USER32.DLL]

    ;LRESULT WINAPI DispatchMessage(
    ;  __in  const MSG *lpmsg
    ;);

jmp .WinMainLoop



ENDAPP:
 ;Get the system termination code of the application
 ;and terminate the program simply with RET:
 ;;
  mov eax,[MSG1.WPARAM.wParam]
  ret














;int CALLBACK WndProc(
;  __in  HWND    hWnd,
;  __in  UINT    messg,
;  __in  WPARAM  wParam,
;  __in  LPARAM  lParam
;);

___WndProc_RVA___ equ $+ImageBase-__code_RVA_Localize__
WndProc:
 push ebp
 mov ebp,esp


 ;See if we got WM_TIMER, and update the time count
 ;in that case:
 ;;
  cmp dword[ebp+0xC],WM_TIMER
  jne .noWM_TIMER
   ;Call our timer printing/updating function:
   ;;
    call time_updater
    xor eax,eax  ;Return 0
    jmp .doneMessageHandling

  .noWM_TIMER:



 ;See if we got WM_PAINT, and redraw the screen as it
 ;would mean that the window contents were overwritten
 ;by another window on top of it, or it was dragged out
 ;of screen limits and then brought back, and such things
 ;that "overwrite" the window contents:
 ;;
  cmp dword[ebp+0xC],WM_PAINT
  jne .noWM_PAINT
    ;Call our timer re-printing function:
    ;;
     call time_reshow

    ;Attempt to update the window contents (it looks like
    ;it allows the timer to be shown precisely and more timely
    ;than without it when moving the window crazily all over
    ;the screen as a stress/performance test for WM_PAINT repainting):
    ;;
     push dword[HWND.myhWnd1]
      call dword[UpdateWindow@USER32.DLL]

    ;BOOL UpdateWindow(
    ;  __in  HWND hWnd
    ;);

    xor eax,eax  ;Return 0
    jmp .doneMessageHandling

  .noWM_PAINT:



 ;See if we got WM_DESTROY, which typically means that the
 ;user simply clicked the close button [X], or used Alt+F4,
 ;or used Alt+Spacebar to select the Close option of the
 ;application's system menu:
 ;;
  cmp dword[ebp+0xC],WM_DESTROY
  je .QuitApplication


 ;This is to have Windows automatically handle
 ;all messages we didn't captured in the cases
 ;just above:
 ;;
  push dword[ebp+0x14]                   ;HWND   hWnd
  push dword[ebp+0x10]                   ;WPARAM wParam
  push dword[ebp+0x0C]                   ;UINT   Msg
  push dword[ebp+0x08]                   ;HWND   hwnd
  call dword[DefWindowProcA@USER32.DLL]

  ;LRESULT WINAPI DefWindowProc(
  ;  __in  HWND    hWnd,
  ;  __in  UINT    Msg,
  ;  __in  WPARAM  wParam,
  ;  __in  LPARAM  lParam
  ;);



 .doneMessageHandling:


 ;Discard the EBP/ESP stack frame:
 ;;
 leave

 ;Pop the 4 DWORD-sized WndProc parameters off the stack:
 ;;
 ret 0x10





 .QuitApplication:
  push byte 0
  call dword[PostQuitMessage@USER32.DLL]  ;Post the "quit" message, WM_QUIT

  ;VOID WINAPI PostQuitMessage(
  ;  __in  int nExitCode
  ;);

  xor eax,eax  ;Return 0


 ;Discard the EBP/ESP stack frame:
 ;;
 leave

 ;Pop the 4 DWORD-sized WndProc parameters off the stack:
 ;;
 ret 0x10







%include "_text/clock/prog.txt"