;Constants to be used with BOOL WINAPI ShowWindow(HWND hWnd, int nCmdShow)
;;
 SW_HIDE            equ 0
 SW_SHOWNORMAL      equ 1
 SW_NORMAL          equ 1
 SW_SHOWMINIMIZED   equ 2
 SW_SHOWMAXIMIZED   equ 3
 SW_MAXIMIZE        equ 3
 SW_SHOWNOACTIVATE  equ 4
 SW_SHOW            equ 5
 SW_MINIMIZE        equ 6
 SW_SHOWMINNOACTIVE equ 7
 SW_SHOWNA          equ 8
 SW_RESTORE         equ 9
 SW_SHOWDEFAULT     equ 10
 SW_FORCEMINIMIZE   equ 11
 SW_MAX             equ 11




;Constants for window messages:
;;
 WM_TIMER   equ 0x0113
 WM_PAINT   equ 0x000F
 WM_DESTROY equ 0x0002



;Some BOOL WINAPI SetWindowPos(HWND hWnd,HWND hWndInsertAfter,int X,int Y,int cx,int cy,UINT uFlags) constants:
;;
 HWND_TOP           equ  0
 HWND_BOTTOM        equ  1
 HWND_TOPMOST       equ -1
 HWND_NOTOPMOST     equ -2

 SWP_NOSIZE         equ 0x0001
 SWP_NOMOVE         equ 0x0002
 SWP_NOZORDER       equ 0x0004
 SWP_NOREDRAW       equ 0x0008
 SWP_NOACTIVATE     equ 0x0010
 SWP_FRAMECHANGED   equ 0x0020
 SWP_SHOWWINDOW     equ 0x0040
 SWP_HIDEWINDOW     equ 0x0080
 SWP_NOCOPYBITS     equ 0x0100
 SWP_NOOWNERZORDER  equ 0x0200
 SWP_NOSENDCHANGING equ 0x0400

 SWP_DRAWFRAME      equ SWP_FRAMECHANGED
 SWP_NOREPOSITION   equ SWP_NOOWNERZORDER

 SWP_DEFERERASE     equ 0x2000
 SWP_ASYNCWINDOWPOS equ 0x4000



;Window styles:
;;
 WS_OVERLAPPED       equ 0x00000000
 WS_POPUP            equ 0x80000000
 WS_CHILD            equ 0x40000000
 WS_MINIMIZE         equ 0x20000000
 WS_VISIBLE          equ 0x10000000
 WS_DISABLED         equ 0x08000000
 WS_CLIPSIBLINGS     equ 0x04000000
 WS_CLIPCHILDREN     equ 0x02000000
 WS_MAXIMIZE         equ 0x01000000
 WS_CAPTION          equ (WS_BORDER|WS_DLGFRAME)
 WS_BORDER           equ 0x00800000
 WS_DLGFRAME         equ 0x00400000
 WS_VSCROLL          equ 0x00200000
 WS_HSCROLL          equ 0x00100000
 WS_SYSMENU          equ 0x00080000
 WS_THICKFRAME       equ 0x00040000
 WS_GROUP            equ 0x00020000
 WS_TABSTOP          equ 0x00010000

 WS_MINIMIZEBOX      equ 0x00020000
 WS_MAXIMIZEBOX      equ 0x00010000

 WS_TILED            equ WS_OVERLAPPED
 WS_ICONIC           equ WS_MINIMIZE
 WS_SIZEBOX          equ WS_THICKFRAME
 WS_TILEDWINDOW      equ WS_OVERLAPPEDWINDOW

 WS_OVERLAPPEDWINDOW equ (WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_THICKFRAME|WS_MINIMIZEBOX|WS_MAXIMIZEBOX)

 WS_POPUPWINDOW      equ (WS_POPUP|WS_BORDER|WS_SYSMENU)

 WS_CHILDWINDOW      equ WS_CHILD



;Extended window styles:
;;
 WS_EX_DLGMODALFRAME  equ 0x00000001
 WS_EX_NOPARENTNOTIFY equ 0x00000004
 WS_EX_TOPMOST        equ 0x00000008
 WS_EX_ACCEPTFILES    equ 0x00000010
 WS_EX_TRANSPARENT    equ 0x00000020

 WS_EX_MDICHILD       equ 0x00000040
 WS_EX_TOOLWINDOW     equ 0x00000080
 WS_EX_WINDOWEDGE     equ 0x00000100
 WS_EX_CLIENTEDGE     equ 0x00000200
 WS_EX_CONTEXTHELP    equ 0x00000400

 WS_EX_RIGHT          equ 0x00001000
 WS_EX_LEFT           equ 0x00000000
 WS_EX_RTLREADING     equ 0x00002000
 WS_EX_LTRREADING     equ 0x00000000
 WS_EX_LEFTSCROLLBAR  equ 0x00004000
 WS_EX_RIGHTSCROLLBAR equ 0x00000000

 WS_EX_CONTROLPARENT  equ 0x00010000
 WS_EX_STATICEDGE     equ 0x00020000
 WS_EX_APPWINDOW      equ 0x00040000

 WS_EX_OVERLAPPEDWINDOW equ (WS_EX_WINDOWEDGE|WS_EX_CLIENTEDGE)
 WS_EX_PALETTEWINDOW    equ (WS_EX_WINDOWEDGE|WS_EX_TOOLWINDOW|WS_EX_TOPMOST)



;Window class styles:
;;
 CS_VREDRAW         equ 0x0001
 CS_HREDRAW         equ 0x0002
 CS_KEYCVTWINDOW    equ 0x0004
 CS_DBLCLKS         equ 0x0008
 CS_OWNDC           equ 0x0020
 CS_CLASSDC         equ 0x0040
 CS_PARENTDC        equ 0x0080
 CS_NOKEYCVT        equ 0x0100
 CS_NOCLOSE         equ 0x0200
 CS_SAVEBITS        equ 0x0800
 CS_BYTEALIGNCLIENT equ 0x1000
 CS_BYTEALIGNWINDOW equ 0x2000
 CS_GLOBALCLASS     equ 0x4000









;Predefined colors:
;;
 CTLCOLOR_MSGBOX           equ 0
 CTLCOLOR_EDIT             equ 1
 CTLCOLOR_LISTBOX          equ 2
 CTLCOLOR_BTN              equ 3
 CTLCOLOR_DLG              equ 4
 CTLCOLOR_SCROLLBAR        equ 5
 CTLCOLOR_STATIC           equ 6
 CTLCOLOR_MAX              equ 7

 COLOR_SCROLLBAR           equ 0
 COLOR_BACKGROUND          equ 1
 COLOR_ACTIVECAPTION       equ 2
 COLOR_INACTIVECAPTION     equ 3
 COLOR_MENU                equ 4
 COLOR_WINDOW              equ 5
 COLOR_WINDOWFRAME         equ 6
 COLOR_MENUTEXT            equ 7
 COLOR_WINDOWTEXT          equ 8
 COLOR_CAPTIONTEXT         equ 9
 COLOR_ACTIVEBORDER        equ 10
 COLOR_INACTIVEBORDER      equ 11
 COLOR_APPWORKSPACE        equ 12
 COLOR_HIGHLIGHT           equ 13
 COLOR_HIGHLIGHTTEXT       equ 14
 COLOR_BTNFACE             equ 15
 COLOR_BTNSHADOW           equ 16
 COLOR_GRAYTEXT            equ 17
 COLOR_BTNTEXT             equ 18
 COLOR_INACTIVECAPTIONTEXT equ 19
 COLOR_BTNHIGHLIGHT        equ 20

 COLOR_3DDKSHADOW          equ 21
 COLOR_3DLIGHT             equ 22
 COLOR_INFOTEXT            equ 23
 COLOR_INFOBK              equ 24

 COLOR_DESKTOP             equ COLOR_BACKGROUND
 COLOR_3DFACE              equ COLOR_BTNFACE
 COLOR_3DSHADOW            equ COLOR_BTNSHADOW
 COLOR_3DHIGHLIGHT         equ COLOR_BTNHIGHLIGHT
 COLOR_3DHILIGHT           equ COLOR_BTNHIGHLIGHT
 COLOR_BTNHILIGHT          equ COLOR_BTNHIGHLIGHT




























;;;;;;;;;;;;INIT: Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;INIT: Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;INIT: Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;INIT: Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;INIT: Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;INIT: Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;INIT: Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;INIT: Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW

;Constants to be used with:
;
;   int WINAPI MessageBox(
;     __in_opt  HWND     hWnd,
;     __in_opt  LPCTSTR  lpText,
;     __in_opt  LPCTSTR  lpCaption,
;     __in      UINT     uType
;   );




;Constants for displaying the different button combinations:
;;
 MB_OK                equ 0x00000000
 MB_OKCANCEL          equ 0x00000001
 MB_ABORTRETRYIGNORE  equ 0x00000002
 MB_YESNOCANCEL       equ 0x00000003
 MB_YESNO             equ 0x00000004
 MB_RETRYCANCEL	      equ 0x00000005
 MB_CANCELTRYCONTINUE equ 0x00000006
 MB_HELP              equ 0x00004000



;Constants for displaying the message box dialog's icon:
;;
 MB_ICONERROR       equ 0x00000010
 MB_ICONHAND        equ 0x00000010
 MB_ICONSTOP        equ 0x00000010
 MB_ICONQUESTION    equ 0x00000020
 MB_ICONEXCLAMATION equ 0x00000030
 MB_ICONWARNING     equ 0x00000030
 MB_ICONASTERISK    equ 0x00000040
 MB_ICONINFORMATION equ 0x00000040



;Constants for specifying the default button:
;;
 MB_DEFBUTTON1 equ 0x00000000
 MB_DEFBUTTON2 equ 0x00000100
 MB_DEFBUTTON3 equ 0x00000200
 MB_DEFBUTTON4 equ 0x00000300



;Constants for specifying the modality of the message box dialog window:
;;
 MB_APPLMODAL   equ 0x00000000
 MB_SYSTEMMODAL equ 0x00001000
 MB_TASKMODAL   equ 0x00002000



;Constants for default desktops, window styles, text alignment...
;;
 MB_DEFAULT_DESKTOP_ONLY equ 0x00020000
 MB_RIGHT                equ 0x00080000
 MB_RTLREADING           equ 0x00100000
 MB_SETFOREGROUND        equ 0x00010000
 MB_TOPMOST              equ 0x00040000
 MB_SERVICE_NOTIFICATION equ 0x00200000



;Constants of the "sane" success return values:
;;
 IDOK       equ 1
 IDCANCEL   equ 2
 IDABORT    equ 3
 IDRETRY    equ 4
 IDIGNORE   equ 5
 IDYES      equ 6
 IDNO       equ 7
 IDTRYAGAIN equ 10
 IDCONTINUE equ 11



;;;;;;;;;;;;END:  Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;END:  Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;END:  Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;END:  Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;END:  Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;END:  Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;END:  Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW
;;;;;;;;;;;;END:  Constants for MessageBoxA MessageBoxW MessageBoxTimeoutA MessageBoxTimeoutW MessageBoxIndirectA MessageBoxIndirectW MessageBoxExA MessageBoxExW














;Default system icons:
;;
 IDI_APPLICATION equ 32512
 IDI_ASTERISK    equ 32516
 IDI_ERROR       equ 32513
 IDI_EXCLAMATION equ 32515
 IDI_HAND        equ 32513
 IDI_INFORMATION equ 32516
 IDI_QUESTION    equ 32514
 IDI_SHIELD      equ 32518
 IDI_WARNING     equ 32515
 IDI_WINLOGO     equ 32517


;Default system cursors:
;;
 IDC_APPSTARTING equ 32650
 IDC_ARROW       equ 32512
 IDC_CROSS       equ 32515
 IDC_HAND        equ 32649
 IDC_HELP        equ 32651
 IDC_BEAM        equ 32513
 IDC_ICON        equ 32641
 IDC_NO          equ 32648
 IDC_SIZE        equ 32640
 IDC_SIZEALL     equ 32646
 IDC_SIZENESW    equ 32643
 IDC_SIZENS      equ 32645
 IDC_SIZENWSE    equ 32642
 IDC_SIZEWE      equ 32644
 IDC_UPARROW     equ 32516
 IDC_WAIT        equ 32514
